{bp}

{* 
 * Problem  : 	EXAM
 * Contest  : 	UOI-2006 (Dnepropetrovsk)
 * Type     : 	Solution
 * Date     : 	March 30, 2006
 * Author   : 	Eugene Yatsenko
 * Language :	Pascal
 * Compiler :	Turbo Pascal 7.0
 * Algorithm:	Optimized Backtracking
 *}

{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}


const
  maxresults = 1000;
var
  n, m     : integer;
  a        : array[1..50, 1..50] of boolean;
  boy, girl: integer;
  fin, fout: text;
  currentPairs : array[1..50, 1..2] of integer;
  bestpairs: array[1..50, 1..2] of integer;
  nCurrentPairs, i, j: integer;
  mingirl, minboy : integer;
  b,g     : array[1..50] of boolean;
  pairFound: boolean;
  maxPairs: integer;
  res     : array[1..50] of byte;
  minres  : array[1..50] of integer;
  bb      : array[1..50, 0..50] of byte;
  boys    : array[1..50] of byte;
  nboys   : byte;
  nresults, nallresults : integer;
  k,kk,tmp: integer;
  pfound  : boolean;
begin
  assign(fin, 'exam.dat');
  reset(fin);
  fillchar(bb, sizeof(bb), 0);
  readln(fin, n,m);
  for i:=1 to m do
    begin
      readln(fin, boy, girl);
      inc(bb[boy][0]);
      bb[boy][bb[boy][0]]:=girl;
      a[boy][girl]:=true;
    end;                                                                                                                     
  close(fin);
  nboys:=0;
  for i:=1 to n do if bb[i][0]>0 then
  begin
    inc(nboys);
    boys[nboys]:=i;
  end;
  mingirl:=1;minboy:=1;
  nCurrentPairs:=0;
  fillchar(b, sizeof(b), false);
  fillchar(g, sizeof(g), false);
  maxPairs:=0;
  nresults:=0;nallresults:=0;
  while(mingirl<=n) and (minboy<=n) do
  begin
    i:=minboy; j:=mingirl;pairFound:=false;
    while(i<=nboys)and not pairFound do
      begin
        boy:=boys[i];
        if (j<=bb[boy][0]) and not b[boy] and not g[bb[boy][j]] then
          begin
            inc(nCurrentPairs);
            currentPairs[nCurrentPairs][1]:=i;
            currentPairs[nCurrentPairs][2]:=j;
            {writeln('Adding pair ',i, ' ', j);}
            if(i<>nboys) then
              begin
                pairFound:=true;
                b[boy]:=true;
                g[bb[boy][j]]:=true;
                minboy:=i+1;
                mingirl:=1;
              end
            else
              begin
                if(maxPairs<=nCurrentPairs) then
                begin
                  for k:=1 to nCurrentPairs do
                    begin
                      res[k*2-1]:=boys[currentPairs[k][1]];
                      res[k*2]:=bb[res[k*2-1]][currentPairs[k][2]];
                    end;
                  for k:=1 to nCurrentPairs *2-1 do
                    for kk:=k+1 to nCurrentPairs *2 do
                      if(res[k]>res[kk]) then
                        begin
                          tmp:=res[k];
                          res[k]:=res[kk];
                          res[kk]:=tmp;
                        end;
                  if(maxPairs<nCurrentPairs) then
                  begin
                    for k:=1 to nCurrentPairs*2 do minres[k]:=res[k];
                    for k:=1 to nCurrentPairs*2 do begin bestpairs[k][1]:=boys[currentPairs[k][1]];
                    bestpairs[k][2]:=bb[boys[currentPairs[k][1]]][currentPairs[k][2]]; end;
                  end
                  else
                    begin
                      pfound:=false;
                      k:=1;
                      while(k<=nCurrentPairs*2) do
                        if(res[k]<minres[k])then
                          begin
                            pfound:=true;
                            break;
                          end
                        else
                        if(res[k]>minres[k]) then break
                        else inc(k);

                      if(pfound) then
                      begin
                        for k:=1 to nCurrentPairs*2 do minres[k]:=res[k];
                        for k:=1 to nCurrentPairs*2 do begin bestpairs[k][1]:=boys[currentPairs[k][1]];
                        bestpairs[k][2]:=bb[boys[currentPairs[k][1]]][currentPairs[k][2]]; end;

                      end;
                    end;
                  maxPairs:=nCurrentPairs;
                end;
                if(j<bb[boy][0]) then inc(j)
                  else
                if(i<=nboys) then
                  begin
                    inc(i);
                    j:=1;
                  end;
                dec(nCurrentPairs);
                {print pair, check}
              end;
          end
        else
          if(j<bb[boy][0]) then inc(j)
        else
          if(i<=nboys) then
        begin
          inc(i);
          j:=1;
        end;
      end;
    if not pairFound then
      begin
        if (nCurrentPairs<>0) then
          begin
           {print pair, check}
                if(maxPairs<=nCurrentPairs) then
                begin
                  for k:=1 to nCurrentPairs do
                    begin
                      res[k*2-1]:=boys[currentPairs[k][1]];
                      res[k*2]:=bb[res[k*2-1]][currentPairs[k][2]];
                    end;
                  for k:=1 to nCurrentPairs *2-1 do
                    for kk:=k+1 to nCurrentPairs *2 do
                      if(res[k]>res[kk]) then
                        begin
                          tmp:=res[k];
                          res[k]:=res[kk];
                          res[kk]:=tmp;
                        end;
                  if(maxPairs<nCurrentPairs) then
                  begin
                    for k:=1 to nCurrentPairs*2 do minres[k]:=res[k];
                    for k:=1 to nCurrentPairs*2 do begin bestpairs[k][1]:=boys[currentPairs[k][1]];
                    bestpairs[k][2]:=bb[boys[currentPairs[k][1]]][currentPairs[k][2]]; end;

                  end
                  else
                    begin
                      pfound:=false;
                      k:=1;
                      while(k<=nCurrentPairs*2) do
                        if(res[k]<minres[k])then
                          begin
                            pfound:=true;
                            break;
                          end
                        else
                        if(res[k]>minres[k]) then break
                        else inc(k);

                      if(pfound) then
                      begin
                        for k:=1 to nCurrentPairs*2 do minres[k]:=res[k];
                        for k:=1 to nCurrentPairs*2 do begin bestpairs[k][1]:=boys[currentPairs[k][1]];
                        bestpairs[k][2]:=bb[boys[currentPairs[k][1]]][currentPairs[k][2]]; end;

                      end
                    end;
                  maxPairs:=nCurrentPairs;
                end;
           minboy:=currentPairs[nCurrentPairs][1];
           mingirl:=currentPairs[nCurrentPairs][2]+1;
           { writeln('removing pair ',minboy, ' ', (mingirl-1));}
           b[boys[minboy]]:=false;
           g[bb[boys[minboy]][mingirl-1]]:=false;
           if(mingirl>bb[boys[minboy]][0]) then
             begin
              inc(minboy);
              mingirl:=1;
             end;
           dec(nCurrentPairs);
          end
        else
          break;
      end;
  end;
  assign(fout, 'exam.sol');
  rewrite(fout);
  if(maxPairs=0) then writeln(fout)
  else
  for i:=1 to maxPairs*2 do write(fout, minres[i], ' ');
  for i:=1 to maxPairs do writeln(bestpairs[i][1],' ', bestpairs[i][2]);
  close(fout);
end.