{ fp }

{* 
 * Problem  : 	LUCKY
 * Contest  : 	UOI-2006 (Dnepropetrovsk)
 * Type     : 	Solution
 * Date     : 	Aprlil 1, 2006
 * Author   : 	Sergey Savchuk
 * Language :	Pascal
 * Compiler :	Free Pascal
 * Algorithm:	Fast backtracking solution wwithout using polish reverse notation
 *}


Var Sol,so: array[0..6] of longint;
    fl: array[0..6] of boolean;
    a: array[1..6] of integer;
    i,Res,Last: longint; n:String;
    fi,fo: Text;

Procedure Calc(nom:integer);
Var  i,l,r,lo,ro,no,nl,nr: Longint;
Begin
     If nom>Sol[0] Then Begin
      If Abs(res)=Abs(Sol[1]) Then
       Begin For i:=1 to So[0] do Write(fo,So[i],' '); Writeln(fo,So[So[0]+1]); close(fo); halt End;
      Exit End;

     no:=a[nom]; l:=Sol[no]; R:=Sol[no+1]; Fl[a[nom]]:=true;

     For i:=a[nom] downto 1 do if not (Fl[i-1])Then Break; nl:=i;
     For i:=a[nom] to 5 do if not (Fl[i]) Then Break; nr:=i;
     lo:=Sol[nl]; ro:=Sol[nr];

     Sol[nl]:=L*R; Sol[nr]:=L*R; Calc(nom+1);
     Sol[nl]:=L+R; Sol[nr]:=L+R; Calc(nom+1);
     Sol[nl]:=L-R; Sol[nr]:=L-R; Calc(nom+1);
     if (R<>0) and (L mod R=0) Then
      Begin Sol[nl]:=L div R; Sol[nr]:=L div R; Calc(nom+1) End;
     Sol[nl]:=lo; Sol[nr]:=ro; Fl[a[nom]]:=false;
End;


Procedure Pere(nom:integer);
Var i,t: Integer;
Begin
     If nom>=Sol[0] Then Begin so:=sol; Calc(1) End Else
      For i:=nom to Sol[0] do Begin
       t:=a[nom]; a[nom]:=a[i]; a[i]:=t;
       Pere(nom+1); a[i]:=a[nom]; a[nom]:=t
      End;
End;

Function StrToInt(S:String):Longint;
Var n: Longint; er:Integer; Begin Val(S,N,er); StrToInt:=N End;

Procedure Gen(K:longint;N:String);
Var i: longint; ln: byte absolute N;
Begin
     If K=0 Then Begin Sol[Sol[0]+1]:=StrToInt(N);
                       For i:=1 to Sol[0] do a[i]:=i; Pere(1); Exit End;
     inc(sol[0]);
     For i:=1 to ln-k do Begin
      Sol[Sol[0]]:=StrToInt(Copy(N,1,i)); Gen(K-1,Copy(N,i+1,ln-i));
     End;
     Dec(Sol[0])
End;

Begin
     Assign(fi,'Lucky.Dat'); Reset(fi); Readln(fi,Res,N); Close(fi);

     Assign(fo,'Lucky.Sol'); ReWrite(fo);
     Delete(N,1,1); For i:=0 to 5 do Gen(i,N);
     Writeln(fo,0); Close(fo)
End.